<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    
    <!-- Import DataTable Library -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.12.1/css/jquery.dataTables.min.css">
    <script src="https://cdn.datatables.net/1.12.1/js/jquery.dataTables.min.js"></script>

    <script src="scource/script.js"></script>

</head>
<body>
    <div class="container">
        <div class="row">
          <div class="col-12 text-center">
           <h2> F200 LỊCH SỬ HỌC TẬP</h2>
          </div>
        </div>
        <div class="jumbotron">
          <div class="row">
            <div class="col-12">
              <h6>Thông Tin Môn Học</h6><br>
              <button class="btn btn-success new-course">New Course</button>
            </div>
          </div>
        </div>
      </div>
      <div class="container">  
        <table class="table table-bordered table-striped table-hover " id="table-users">
          <thead>
            <tr>
              <th>STT</th>
              <th>Course Name</th>
              <th>Level</th>
              <th>Price</th>
              <th>Discount Price</th>
              <th>Teacher Name</th>
              <th>Teacher Photo</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody>
    
          </tbody>
        </table>
      </div>

      <!-- create new course -->
      <div>
        <div id="create-course-modal" class="modal fade" tabindex="-1">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title" id="h5-modal-title">Add Course</h5>
                <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="input-create-course-code">Course Name</label>
                    </div>
                    <div class="col-sm-8">
                      <input type="text" id="inp-course-name-modal-create" name="course-modal-create" placeholder="Course Name" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="input-create-discount">Level</label>
                    </div>
                    <div class="col-sm-8">
                      <input type="text" id="inp-level-modal-create" name="lastname-modal-create" placeholder="Level" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="input-create-discount">Price</label>
                    </div>
                    <div class="col-sm-8">
                      <input type="text" id="inp-price-modal-create" name="subject-modal-create" placeholder="Price" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="input-create-discount">Discount Price</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" id="inp-price-discount-modal-create" name="subject-modal-create" placeholder="Discount Price" class="form-control">
                    </select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="input-create-discount">Teacher Name</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" id="inp-teacher-name-modal-create" name="subject-modal-create" placeholder="Teacher Name" class="form-control">
                    </select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="input-create-discount">Teacher Photo</label>
                    </div>
                    <div class="col-sm-8">
                        <form >
                            <label for="img">Select image:</label>
                            <input type="file" id="img-teacher-create" name="img" accept="image/*"  />
                            <hr>
                            <button class="btn btn-secondary" id="btn-cancel-course" data-dismiss="modal">Cancel</button>
                            <button class="btn btn-primary" id="btn-create-course" type="submit">Insert Course</button>
                        </form>
                    </div>
                  </div>
                
              </div>
              <div class="modal-footer">
              
              </div>
           
            </div>
          </div>
        </div>
      </div>
          <!-- edit modal  -->
      <div>
        <div id="edit-course-modal" class="modal fade" tabindex="-1">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title" id="h5-modal-title">Add Course</h5>
                <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="input-edit-course-code">Course Name</label>
                    </div>
                    <div class="col-sm-8">
                      <input type="text" id="inp-course-name-modal-edit" name="course-modal-create" placeholder="Course Name" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="input-create-discount">Level</label>
                    </div>
                    <div class="col-sm-8">
                      <input type="text" id="inp-level-modal-edit" name="lastname-modal-create" placeholder="Level" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="input-create-discount">Price</label>
                    </div>
                    <div class="col-sm-8">
                      <input type="text" id="inp-price-modal-edit" name="subject-modal-create" placeholder="Price" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="input-create-discount">Discount Price</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" id="inp-price-discount-modal-edit" name="subject-modal-create" placeholder="Discount Price" class="form-control">
                    </select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="input-create-discount">Teacher Name</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" id="inp-teacher-name-modal-edit" name="subject-modal-create" placeholder="Teacher Name" class="form-control">
                    </select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="input-create-discount">Teacher Photo</label>
                    </div>
                    <div class="col-sm-8">
                        <form >
                            <label for="img">Select image:</label>
                            <input type="file" id="img-teacher-edit" name="img" accept="image/*"  />
                            <hr>
                            <button class="btn btn-secondary" id="btn-cancel-edit-course" data-dismiss="modal">Cancel</button>
                            <button class="btn btn-primary" id="btn-edit-course" type="submit">Insert Course</button>
                        </form>
                    </div>
                  </div>
                
              </div>
              <div class="modal-footer">
              
              </div>
            </div>
          </div>
        </div>
      </div>

      <!-- delete modal -->
      <div>
        <div class="modal fade" tabindex="-1" id="delete-modal">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title" id="h5-modal-title">Course Delete Confirmation</h5>
                <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <label>Bạn có chắc chắn muốn xóa khoá học này không?</label>
              </div>
              <div class="modal-footer">
                <button class="btn btn-danger" id="btn-confirm-delete-course">Confirm</button>
                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
              </div>
            </div>
          </div>
        </div>
      </div>
</body>
</html>
<script>
        const gARRAY_COL_NAME = ["stt", "courseName", "level", "price", "discountPrice","teacherName","teacherPhoto","action"];
        const gCOL_STT = 0;
        const gCOL_COURSE_NAME = 1;
        const gCOL_LEVEL = 2;
        const gCOL_PRICE = 3;
        const gCOL_DISCOUNT_PRICE = 4;
        const gCOL_TEACHER_NAME = 5 ;
        const gCOL_TEACHER_PHOTO = 6 ;
        const gCOL_ACTION = 7 ;

      var gSTT = 0;
      var gIdCourse = 0;

      var gCourseCreate = {
        courseName:"",
        level:"",
        price:0,
        discountPrice:0,
        teacherName:"",
        teacherPhoto:""
      }

      var gCourseEdit = {
        courseName:"",
        level:"",
        price:0,
        discountPrice:0,
        teacherName:"",
        teacherPhoto:""
      }
      $(document).ready(function(){
       
       
   
      var gUserTabble = $('#table-users').DataTable({     
          data:gCoursesDB.courses,
          columns:[  
            { data: gARRAY_COL_NAME[gCOL_STT] },
            { data: gARRAY_COL_NAME[gCOL_COURSE_NAME] },
            { data: gARRAY_COL_NAME[gCOL_LEVEL] },
            { data: gARRAY_COL_NAME[gCOL_PRICE] },
            { data: gARRAY_COL_NAME[gCOL_DISCOUNT_PRICE] },
            { data: gARRAY_COL_NAME[gCOL_TEACHER_NAME] },
            { data: gARRAY_COL_NAME[gCOL_TEACHER_PHOTO] },
            { data: gARRAY_COL_NAME[gCOL_ACTION] }
          ],
          columnDefs:[
              { 
                targets:gCOL_STT, 
                render: function(){
                  gSTT++;
                  return gSTT;
                }
              },
              { 
                targets:gCOL_PRICE, 
                render: function(data){
                    return  data + "$"
                }
              },     
              { 
                targets:gCOL_DISCOUNT_PRICE, 
                render: function(data){
                    return  data + "$"
                }
              },    
              {
                targets: gCOL_TEACHER_PHOTO,
                render: function(data) {
                    return '<img src="'+ data +'" class="img-fluid img-thumbnail">'
                }
              },
              {
                targets: gCOL_ACTION,
                defaultContent : "<i class='fas fa-edit' style='color:green ; cursor:pointer' title='Edit' ></i> <i class='fas fa-trash-alt' style='color:red ; cursor:pointer' title='Delete'></i>"
              }
          ]
        });
        
        // vùng 3 nút thêm , sửa , xóa
        $(document).on("click" , ".new-course" , function(){
                console.log("tạo mới môn học")
                $("#create-course-modal").modal("show");
        })
        $("#btn-create-course").on("click" , function(e){
           e.preventDefault();

            
            console.log("nút create dc ấn");
            getDataToCreaate();

            var vCheck = checkDataCreate()

            if (vCheck == true){
                
                gCoursesDB.courses.push(gCourseCreate);
                
                loadDataRowToTable(gCoursesDB.courses);

                $("#create-course-modal").modal("hide");
            }

            
            
        })
        $(document).on("click" , ".fa-edit" , function(){
                console.log("sửa môn học")
                $("#edit-course-modal").modal("show");
                loadDataToUpdateForm(this);
        })
        $(document).on("click" , ".fa-trash-alt" , function(){
                console.log("xóa môn học")
                getIdToDelete(this);
                $("#delete-modal").modal("show");
                
        })
        $(document).on("click" , "#btn-edit-course" , function(e){
            e.preventDefault();
            
            gCourseEdit.courseName = $("#inp-course-name-modal-edit").val()  ;
            gCourseEdit.level = $("#inp-level-modal-edit").val()
            gCourseEdit.price = $("#inp-price-modal-edit").val()
            gCourseEdit.discountPrice = $("#inp-price-discount-modal-edit").val() ;
            gCourseEdit.teacherName = $("#inp-teacher-name-modal-edit").val() ;

            editCouse(gCourseEdit);

            $("#edit-course-modal").modal("hide");

            loadDataRowToTable(gCoursesDB.courses);

        })

        $(document).on("click" , "#btn-confirm-delete-course" , function(){
        
          deleteVoucher(gIdCourse);
         
          loadDataRowToTable(gCoursesDB.courses);
          $('#delete-modal').modal('hide');
        })
        function deleteVoucher(paramVoucherId) {
          var vCourseIndex = getDataIdCourse(paramVoucherId);
          gCoursesDB.courses.splice(vCourseIndex, 1);
        }
        function getIdToDelete(paramButton){
          var vTableRow = $(paramButton).parents("tr");
          var vVoucherRowData = gUserTabble.row(vTableRow).data();

          console.log(vVoucherRowData.id);

          gIdCourse = vVoucherRowData.id
        }
        function loadDataToUpdateForm(paramButton){
            var vTableRow = $(paramButton).parents("tr");
            var vVoucherRowData = gUserTabble.row(vTableRow).data();

            console.log(vVoucherRowData.id);
            
            $("#inp-course-name-modal-edit").val(vVoucherRowData.courseName) ;
            $("#inp-level-modal-edit").val(vVoucherRowData.level) ;
            $("#inp-price-modal-edit").val(vVoucherRowData.price) ;
            $("#inp-price-discount-modal-edit").val(vVoucherRowData.discountPrice) ;
            $("#inp-teacher-name-modal-edit").val(vVoucherRowData.teacherName) ;

            gIdCourse = vVoucherRowData.id
            
        }

        function editCouse(paramEditObj) {
          var vCourseIndex = getDataIdCourse(gIdCourse);
          gCoursesDB.courses.splice(vCourseIndex, 1, paramEditObj);
      }
        function getDataIdCourse(paramCourseId) {
          var vCouseIndex = -1;
          var vCouseFound = false;
          var bI = 0;
          while(!vCouseFound && bI < gCoursesDB.courses.length) {
            if(gCoursesDB.courses[bI].id === paramCourseId) {
              vCouseIndex = bI;
              vCouseFound = true;
            }
            else {
              bI ++;
            }
          }
          return vCouseIndex;
        }
        // vùng gán dữ liệu , check dữ liệu , xử lý
        function getDataToCreaate() {
            gCourseCreate.courseName = $("#inp-course-name-modal-create").val()  ;
            gCourseCreate.level = $("#inp-level-modal-create").val()
            gCourseCreate.price = $("#inp-price-modal-create").val()
            gCourseCreate.discountPrice = $("#inp-price-discount-modal-create").val() ;
            gCourseCreate.teacherName = $("#inp-teacher-name-modal-create").val() ;
            
            gCourseCreate.teacherPhoto = $("#img-teacher-create").val()

            console.log(gCourseCreate.teacherPhoto)
           
        }
      
        function checkDataCreate (){
            if (gCourseCreate.courseName == ""){
                alert("nhập vào tên môn")
                return false ;
            }
            if (gCourseCreate.level == ""){
                alert("nhập vào trình độ")
                return false ;
            }
            if (isNaN(gCourseCreate.price)){
                alert("nhập vào giá gốc , giá gốc phải là số")
                return false ;
            }
            if (isNaN(gCourseCreate.discountPrice)){
                alert("nhập vào giá giảm ,  giá giảm phải là số")
                return false ;
            }
            if (gCourseCreate.teacherName == ""){
                alert("nhập vào tên giáo viên")
                return false ;
            }
            return true ; 
        }
        // thẻ input img 
       
        // vùng hiển thị lên bảng
        function loadDataRowToTable(paramData){
        var vTable = $("#table-users").DataTable();
        gSTT = 1 ;
        vTable.clear(paramData);
        vTable.rows.add(paramData);
        vTable.draw();
        }

    })   
    
</script>